
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

#define btnDEBOUNCE 10
#define btnHOLD 500


bool btnPress = false;
unsigned long timePress = 0;
int btnARead = 1023;


bool btnPressed() {
  int x = analogRead (0);
  if (x < 800) {  //button pressed
    if (btnPress == false) {  //first event
      btnPress = true;  //flag the event
      timePress = millis(); //and record the timestamp
      return false; //wait for debounce
    }
    else if (millis() - timePress > btnDEBOUNCE) {  //debounce ok
      btnARead = x;  //store the value
      return true;
    }
  return false; //debounce nok
  }
  else {
    return false; //button not pressed
  }
}


bool btnHold() {
  int x = analogRead (0);
  if ((btnPress) && (millis() - timePress > btnHOLD) && (btnARead > x - 100) && (btnARead < x + 100)) {
    timePress = millis();
    return true; //button hold
  }
  else return false;
}


bool btnReleased() {
  int x = analogRead (0);
  if ((x >= 800) && (btnPress)) { //button release
    btnPress = false;
    btnARead = x;
    timePress = 0;
    return true;
  }
  else return false;
}


int btnRead() {
  int x = btnARead;
  if (x > 1000) return btnNONE;
  else if (x < 50) return btnRIGHT;
  else if (x < 250) return btnUP;
  else if (x < 400) return btnDOWN;
  else if (x < 600) return btnLEFT;
  else if (x < 800) return btnSELECT;
  else return btnNONE;
} 
